<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/exif.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["project"]["plugins"]."unit_testing/ut/core.php");
 require_once($_path["include"]."exif.php");

 class UT_EXIF extends UT_Classes
 {
  function Constructor()
  {
   $object=new EXIF();

   if(!is_object($object)||get_class($object)!="EXIF")
   {
    $this->e->add("Constructor doesn't return a EXIF object", "error");
    return UT_FAILED;
   }

   if(!is_object($object->e)||get_class($object->e)!="Errors")
   {
    $this->e->add("Object: \"e\" isn't an Errors object", "error");
    return UT_FAILED;
   }

   if($object->exif!==false)
   {
    $this->e->add("Exif value isn't false", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Copy_Constructor()
  {
   $orig=new EXIF();
   $copy=clone $orig;

   if(!$this->_compare($orig, $copy))
   {
    $this->e->add("Exif object copy doesn't match original", "error");
    return UT_FAILED;
   }

   $copy->exif=true;
   if($orig->exif==$copy->exif)
   {
    $this->e->add("Exif object copy also modified original \"exif\" variable", "error");
    return UT_FAILED;
   }

   $copy->e->errors=-1;
   if($orig->e->errors==$copy->e->errors)
   {
    $this->e->add("Exif object copy also modified original \"Error\" object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function Read()
  {
   return UT_SKIPPED;
  }

  function Get()
  {
   return UT_SKIPPED;
  }

  function Info()
  {
   return UT_SKIPPED;
  }

  function Time()
  {
   return UT_SKIPPED;
  }

  function Orientation()
  {
   return UT_SKIPPED;
  }

  function Size()
  {
   return UT_SKIPPED;
  }

  function Width()
  {
   return UT_SKIPPED;
  }

  function Height()
  {
   return UT_SKIPPED;
  }

  function Exposure()
  {
   return UT_SKIPPED;
  }

  function Aperture()
  {
   return UT_SKIPPED;
  }

  function Iso()
  {
   return UT_SKIPPED;
  }

  function Camera()
  {
   return UT_SKIPPED;
  }

  function Set()
  {
   return UT_SKIPPED;
  }

  function Write()
  {
   return UT_SKIPPED;
  }

 }

?>
