<?

 /*****************************************************************************
 * Filename: include/plugins/unit_testing/ut/jas.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["project"]["plugins"]."unit_testing/ut/core.php");
 require_once($_path["include"]."jas.php");

 class JAS_EXTENDS_TEST extends JAS
 {
 }

 class UT_JAS extends UT_Classes
 {
  function Constructor()
  {
   $object=new JAS();

   if(!is_object($object)||get_class($object)!="JAS")
   {
    $this->e->add("Constructor doesn't return a JAS object", "error");
    return UT_FAILED;
   }

   if(!is_object($object->e)||get_class($object->e)!="Errors")
   {
    $this->e->add("Object: \"e\" isn't an Errors object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

  function Copy_Constructor()
  {
   $orig=new JAS();
   $copy=clone $orig;

   if(!$this->_compare($orig, $copy))
   {
    $this->e->add("JAS object copy doesn't match original", "error");
    return UT_FAILED;
   }

   $copy->e->errors=-1;
   if($orig->e->errors==$copy->e->errors)
   {
    $this->e->add("JAS object copy also modified original \"Error\" object", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }


  function Version()
  {
   global $_path;

   $j=new JAS();

   if(!($changelog=file_get_contents($_path["include"]."changelog.txt")))
   {
    $this->e->add("Can't get version from changelog file", "error");
    return UT_FAILED;
   }

   if(!preg_match("/\nVersion ([0-9\.]+)[ \-]*([A-Z0-9]+)?/i", $changelog, $version))
   {
    $this->e->add("Can't get version from changelog file", "error");
    return UT_FAILED;
   }

   $development=(preg_match("/\nDevelopment version/", $changelog));

   if(!preg_match("/\n\t(\d{4}-\d{2}-\d{2})/", $changelog, $updated))
   {
    $this->e->add("Can't get version from changelog file", "error");
    return UT_FAILED;
   }

   $updated=DT::dateConvertS($updated[1], "Y-m-d");
   $modified=filemtime($_path["include"]."changelog.txt");

   //version
   if(!$j->version())
   {
    $this->e->add("JAS version failed", "error");
    $this->e->add($j->e);
    return UT_FAILED;
   }

   if($j->version()!=$version[1])
   {
    $this->e->add("JAS version doesn't match", "error");
    return UT_FAILED;
   }

   if(!$j->version("version"))
   {
    $this->e->add("JAS version failed", "error");
    $this->e->add($j->e);
    return UT_FAILED;
   }

   if($j->version("version")!=$version[1])
   {
    $this->e->add("JAS version doesn't match", "error");
    return UT_FAILED;
   }

   //tag
   if($j->version("tag")===false)
   {
    $this->e->add("JAS version tag failed", "error");
    $this->e->add($j->e);
    return UT_FAILED;
   }

   if($j->version("tag")!=(isset($version[2])?$version[2]:""))
   {
    $this->e->add("JAS version tag doesn't match", "error");
    return UT_FAILED;
   }

   //development
   if($j->version("development")!=$development)
   {
    $this->e->add("JAS version development doesn't match", "error");
    return UT_FAILED;
   }

   //updated
   if(!$j->version("updated"))
   {
    $this->e->add("JAS version updated failed", "error");
    $this->e->add($j->e);
    return UT_FAILED;
   }

   if(date("Y-m-d", $j->version("updated"))!=date("Y-m-d", $updated))
   {
    $this->e->add("JAS version updated doesn't match", "error");
    return UT_FAILED;
   }

   //modified
   if(!$j->version("modified"))
   {
    $this->e->add("JAS version modified failed", "error");
    $this->e->add($j->e);
    return UT_FAILED;
   }

   if($j->version("modified")!=$modified)
   {
    $this->e->add("JAS version modified doesn't match", "error");
    return UT_FAILED;
   }

   return UT_OK;
  }

 }


 class UT_Modules_Function extends UT_JAS
 {
  function isArray()
  {
   $j=new JAS();
   if(!is_array($j->modules()))
    return UT_FAILED;

   return UT_OK;
  }
  function WrongType()
  {
   $j=new JAS();
   if(sizeof($j->modules("asdasasdasdasdads"))>0)
    return UT_FAILED;

   return UT_OK;
  }
  function Categories()
  {
   $j=new JAS();
   if(!in_array("categories", $j->modules("system")))
    return UT_FAILED;

   return UT_OK;
  }
  function Plugins()
  {
   $j=new JAS();
   if(!in_array("unit_testing_mutilate", $j->modules("plugins", "unit_testing")))
    return UT_FAILED;

   return UT_OK;
  }
  function TableExists()
  {
   $j=new JAS();
   if(!in_array("categories", $j->modules(false, false, true)))
    return UT_FAILED;

   return UT_OK;
  }
  function TableDoesntExists()
  {
   $j=new JAS();
   if(in_array("empty", $j->modules("project", false, true)))
    return UT_FAILED;

   return UT_OK;
  }
 }


 class UT_Plugins_Function extends UT_JAS
 {
  function isArray()
  {
   $j=new JAS();
   if(!is_array($j->plugins()))
    return UT_FAILED;

   return UT_OK;
  }
  function WrongType()
  {
   $j=new JAS();
   if(sizeof($j->plugins("asdasasdasdasdads"))>0)
    return UT_FAILED;

   return UT_OK;
  }
  function Categories()
  {
   $j=new JAS();
   if(!in_array("unit_testing", $j->plugins("system")))
    return UT_FAILED;

   return UT_OK;
  }
 }

 class UT_Projects_Function extends UT_JAS
 {
  function isArray()
  {
   $j=new JAS();
   if(!is_array($j->projects()))
    return UT_FAILED;

   return UT_OK;
  }
  function Exists()
  {
   $j=new JAS();
   if(!in_array("jas", $j->projects()))
    return UT_FAILED;

   return UT_OK;
  }
 }

?>
